/*******************************************************************************
*									       *
*                U   U M   M DDDD     OOOOO SSSSS PPPPP FFFFF		       *
*                U   U MM MM D   D    O   O S     P   P F		       *
*                U   U M M M D   D    O   O  SSS  PPPPP FFFF		       *
*                U   U M M M D   D    O   O     S P     F		       *
*                 UUU  M M M DDDD     OOOOO SSSSS P     F		       *
*									       *
*    		          Copyright 1989, 1990, 1991               	       *
*    	       The University of Maryland, College Park, Maryland.	       *
*								               *
*			    All Rights Reserved				       *
*									       *
*     The University of Maryland College Park ("UMCP") is the owner of all     *
*     right, title and interest in and to UMD OSPF (the "Software").           *
*     Permission to use, copy and modify the Software and its documentation    *
*     solely for non-commercial purposes is granted subject to the following   *
*     terms and conditions:						       *
*								               *
*     1. This copyright notice and these terms shall appear in all copies      *
*	 of the Software and its supporting documentation.		       *
*									       *
*     2. The Software shall not be distributed, sold or used in any way in     *
*	 a commercial product, without UMCP's prior written consent.           *
*									       *
*     3. The origin of this software may not be misrepresented, either by      *
*        explicit claim or by omission.					       *
*    									       *
*     4. Modified or altered versions must be plainly marked as such, and      *
*	 must not be misrepresented as being the original software.	       *
*     									       *
*     5. The Software is provided "AS IS". User acknowledges that the          *
*        Software has been developed for research purposes only. User          *
*	 agrees that use of the Software is at user's own risk. UMCP	       *
*	 disclaims all warrenties, express and implied, including but          *
*	 not limited to, the implied warranties of merchantability, and        *
*	 fitness for a particular purpose.				       *
*									       *
*    Royalty-free licenses to redistribute UMD OSPF are available from	       *
*    The University Of Maryland, College Park. 			               *
*      For details contact:						       *
*	        Office of Technology Liaison 				       *
*		4312 Knox Road     					       *
*		University Of Maryland					       *
*		College Park, Maryland 20742				       *
*		     (301) 405-4209					       *
*		FAX: (301) 314-9871    					       *
*									       *
*    This software was written by Rob Coltun				       *
*     rcoltun@ni.umd.edu						       *
*									       *
*******************************************************************************/

extern void add_ack();
extern int nbr_rem_req();
extern struct LSDB *findLSA();

/*
 *	 STRUCTURES FOR THE SPF ALGORITHM
 */

/* MODIFIED 2/13/92 - removed all references to blocksize and BLOCKSIZE */

/* Link State Database */


#define HTBLSIZE	31
#define HTBLMOD		(HTBLSIZE)	/* sb prime (or there aboutst) */

#define XHASH(A1,A2)	((A1) % HTBLMOD)

union LSA_PTR {				/* advertisements */
    struct RTR_LA_HDR *rtr;
    struct NET_LA_HDR *net;
    struct SUM_LA_HDR *sum;
    struct ASE_LA_HDR *ase;
};

#define ADVNULL ((struct RTR_LA_HDR *) 0)

#define DB_CAN_BE_FREED(DB)\
	( (DB_FREEME(DB)) &&\
	  (!(DB_ACK_CNT(DB))) &&\
	  ((!DB_RETRANS(DB))) &&\
	  (!(DB_ROUTE(DB) || DB_ASB_RTR(DB))) &&\
	  (ospf.nbrEcnt == ospf.nbrFcnt) )

#define ADV_RTR(DB) 	((DB)->adv.rtr->ls_hdr.adv_rtr)
#define ADV_AGE(DB,T)   (LS_AGE(DB) + (T - DB_TIME(DB)))
#define LS_AGE(DB) 	(DB->adv.rtr->ls_hdr.ls_age)
#define LS_ID(DB) 	((DB)->adv.rtr->ls_hdr.ls_id)
#define LS_TYPE(DB) 	((DB)->adv.rtr->ls_hdr.ls_type)
#define LS_SEQ(DB) 	((DB)->adv.rtr->ls_hdr.ls_seq)
			/* MODIFIED 2/5/92 */
#define LS_CKS(DB) 	ntohs((DB)->adv.rtr->ls_hdr.ls_chksum)
#define LS_LEN(DB) 	((DB)->adv.rtr->ls_hdr.length)

#define GOT_GUTS(DB)	((DB_GUTS(DB) != DBGUTSNULL))
#define NO_GUTS(DB)	((DB_GUTS(DB) == DBGUTSNULL))
#define DB_GUTS(DB)	((DB)->un2.dbguts)
#define DB_PTR(DB) 	((DB)->un2.dbguts)->ptr
#define DB_TIME(DB) 	((DB)->un2.dbguts->time_stamp)
#define DB_NEXT(DB)	((DB)->lsdbnext)
#define DB_WHERE(DB) 	((DB)->un2.dbguts->where)
#define DB_MY_AREA_NDX(DB) ((DB)->un2.dbguts->my_area_ndx)
#define DB_DIRECT(DB) 	((DB)->un2.dbguts->direct)
#define DB_VIRTUAL(DB) 	((DB)->un2.dbguts->virtual)
#define DB_FREEME(DB) 	((DB)->un2.dbguts->freeme)
#define DB_SEQ_MAX(DB) 	((DB)->un2.dbguts->seq_max)
#define DB_ACK_CNT(DB) 	((DB)->un2.dbguts->ackcnt)
#define DB_NH_CNT(DB) 	((DB)->un2.dbguts->nhcnt)
/* MODIFIED 1/10 */
#define DB_NH_NDX(DB,NDX) ((DB)->un2.dbguts->nhndx[NDX])
#define DB_DIST(DB) 	((DB)->un2.dbguts->dist)
#define DB_COUNT(DB) 	((DB)->un2.dbhinfo.count)
#define DB_RERUN(DB) 	((DB).un2.dbhinfo.rerunflag)
#define DB_MYHASH(DB) 	((DB)->un2.dbguts->myhash)
#define DB_TRANS_AREA_NDX(DB) ((DB)->un2.dbguts->trans_area_ndx)
#define DB_ADV(DB) 	((DB)->adv)
#define DB_RTR(DB) 	((DB)->adv.rtr)
#define DB_NET(DB) 	((DB)->adv.net)
#define DB_SUM(DB) 	((DB)->adv.sum)
#define DB_ASE(DB) 	((DB)->adv.ase)
#define DB_LS_HDR(DB)	(DB_RTR(DB)->ls_hdr)
#define DB_MASK(DB) 	(DB_NET(DB)->net_mask)
#define DB_NETNUM(DB)  	(LS_ID(DB) & DB_MASK(DB))
#define DB_RETRANS(DB) 	((DB)->un2.dbguts->retrans)
#define DB_BDR(DB)	((DB)->border)
#define DB_ROUTE(DB) 	((DB)->un1.route)
#define DB_AB_RTR(DB) 	((DB)->un1.ab_rtr)
#define DB_ASB_RTR(DB) 	((DB)->asb_rtr)
#define	DB_BDR_AB(L)	(DB_AB_RTR(DB_BDR(L)))
#define	DB_BDR_ASB(L)	(DB_ASB_RTR(DB_BDR(L)))
#define DB_ASE_TAG(DB)	(DB_ASE((DB))->tos0.ExtRtTag)
#define DB_ASE_FORWARD(DB) (DB_ASE((DB))->tos0.ForwardAddr)

/*
 * The guts of the lsdb structure
 */
struct DBGUTS {
    struct LSDB *ptr[2]; /* for candidate, sum and ase list */
    BIT_FIELD where:8,	/* where this vertex is: on candidate lst or spftree
		           for ls_ase could be on ase_infinity or ase_list */
#define UNINITIALIZED	0
#define	ON_CLIST	1
#define ON_SPFTREE	2
#define ON_RTAB		2
#define ON_SUMASB_LIST	3	/* reachable asb from attached area */
#define ON_SUMNET_LIST	4	/* reachable net from attached area */
#define ON_INTER_LIST	5	/* on inter-area list - imported from bb */
#define	ON_SUM_INFINITY 6
#define ON_ASE_LIST	7
#define ON_ASE_INFINITY 8
     direct:1,			/* net attached to this node */
     freeme:1,			/* flag to free this lsdb entry */
     seq_max:1,			/* note if entry has reached max seq number */
     virtual:1, 
     trans_area_ndx:8,		/* For resolution of virtual nbrs */
     my_area_ndx:12;		/* for keeping count of db's in each area */
    u_short16 nhcnt;		/* number of in-use parents (< MAXNH) */
    u_short16 ackcnt;		/* ack reference count - don't free until 0 */
    u_char8 myhash;		/* this db's hash */
    u_char8 nhndx[MAXNH];	/* list of next hops */
    u_long32 dist;		/* distance to root */
    time_t time_stamp;		/* for keeping age - stamped when arrived */
    struct NBR_LIST *retrans;	/* nbrs pointing to this lsdb */
};

/*
 * If greater than 255 possible nexthops, nhndx should be changed to a short
 */

#define DBGUTSNULL ((struct DBGUTS *)0)

struct DBHEAD_INFO {
    u_short16 rerunflag;	/* rerun this row - partial update */
    u_short16 count;		/* count of lsdb elts; used in head */
};

struct LSDB {
    struct LSDB *lsdbnext;	/* LSDB list */
    u_long32 key[2];		/* LSDB keys - ls_id & adv rtr */
    union LSA_PTR adv;		/* advertisement */
    union {
	OROUTE *route;		/* pointer to the routing table entry */
	RTR_ROUTE *ab_rtr;	/* Area bdr rtr */
    } un1;
    RTR_ROUTE *asb_rtr;		/* if it is ASB Router */
    struct LSDB *border;	/* sum or ase - lsdb of border rtr */
    union UN {
	struct DBHEAD_INFO dbhinfo;
	struct DBGUTS *dbguts;
    } un2;
};

#define  GOT_A_BDR(L) 	   (GOT_GUTS(L) && DB_BDR(L) != LSDBNULL)
#define  ABRTR_ACTIVE(L)   (GOT_GUTS(L) && DB_BDR_AB(L) != RTR_ROUTENULL)
#define  ASBRTR_ACTIVE(L)  (GOT_GUTS(L) && DB_BDR_ASB(L) != RTR_ROUTENULL)

#define LSDBNULL	((struct LSDB *)0)

/* 
 * structures for keeping track of retransmission lists 
 */

/* 
 * lsdb keeps track of nbrs pointing to it for tx and retx 
 */
struct NBR_LIST {
    struct NBR_LIST *ptr[2];
    struct NBR *nbr;
};

#define NLNULL	((struct NBR_LIST *) 0)

/* 
 * for db retrans 
 */
struct DBRT_LIST {
    struct DBRT_LIST *ptr[2];
    struct LSDB *lsdb;
};

#define DBRTNULL	((struct DBRT_LIST *) 0)

/*
 * General queue structure for sending advertisements
 */
struct LSDB_LIST {
    struct LSDB_LIST *ptr[2];
    struct LSDB *lsdb;
    int flood;				/* true if flooding this one */
};

#define LLNULL	((struct LSDB_LIST *) 0)

/* 
 * for sending acks 
 */
struct ACK_LIST {			
    struct ACK_LIST *ptr[2];
    struct LSDB *db;
};

#define ACKNULL	((struct ACK_LIST *)0)

/*
 * Used by RxLinkup
 * Information about a specific received LSA
 */
struct DB_INFO {
    int mc;			/* TRUE if RX by multicast */
    int len; 			/* Length of new adv */
    int foundlsa;		/* If found in lsdb or not */
    struct LSDB *db; 		/* Current or to be installed db struct */
    struct AREA *area;	 	/* Associated area */
    struct INTF *intf; 		/* Interface received on */
    struct NBR *nbr;		/* Neighbor received on */
    union LSA_PTR adv; 		/* New advertisement */
    time_t sec;			/* Current time */
    time_t diff;		/* Difference between sec and db orig rx time */
};


/* Return values for nbr_ret_req */
#define REQ_NOT_FOUND 		0
#define REQ_LESS_RECENT 	1
#define REQ_SAME_INSTANCE 	2
#define REQ_MORE_RECENT 	3

#define ASE_COST_LESS(A_ETYPE,A_COST,A_TYPE2COST,B_ETYPE,B_COST,B_TYPE2COST)\
	( ((!A_ETYPE) && (B_ETYPE)) ||\
   	   ( ((!A_ETYPE) && (!B_ETYPE)) &&\
	      ((A_COST) < (B_COST)) ) ||\
   	   ( ((A_ETYPE) && (B_ETYPE)) &&\
	     ( ((A_TYPE2COST) < (B_TYPE2COST)) ||\
               ((A_TYPE2COST) == (B_TYPE2COST)) && ((A_COST) < (B_COST)) ) ) )

#define ASE_COST_EQUAL(A_ETYPE,A_COST,A_TYPE2COST,B_ETYPE,B_COST,B_TYPE2COST)\
	( ((A_ETYPE) == (B_ETYPE)) &&\
	  ((A_COST) == (B_COST)) &&\
	  ((A_TYPE2COST) == (B_TYPE2COST)) )

/* Queue general hdrs */
#define NEXT 0
#define LAST 1

/* 
 * an empty struct for general doubly-linked queueing 
 */
struct Q {		
    struct Q *ptr[2];	/* 0 is foward ptr, 1 is back ptr */
};

#define QNULL ((struct Q *)0)

/*
 * For LSDB Access 
 */
#define Xkey1(A) ((A)->ls_hdr.ls_id)
#define Xkey2(A) ((A)->ls_hdr.adv_rtr)
#define Xtype(A) ((A)->ls_hdr.ls_type)
#define XXhash(A) (XHASH(Xkey1(A),Xkey1(A)))

#define XThash(K1,K2,T) (XHASH(K1,K1))

#define XAddLSA(DB,Area,X,Data) addLSA(DB,Area,Xkey1(X),Xkey2(X),Data,Xtype(X))

#define AddLSA(DB,Area,K1,K2,Data,Typ) addLSA(DB,Area,K1,K2,Data,Typ)

#define XFindLSA(Area,X)\
     	(struct LSDB *)findLSA(&(Area->htbl[Xtype(X)][XXhash(X)]),\
		Xkey1(X),Xkey2(X),Xtype(X))

#define FindLSA(Area,K1,K2,Typ)\
  	(struct LSDB *)findLSA(&(Area->htbl[Typ][XThash(K1,K2,Typ)]),K1,K2,Typ)

/*
 * Add Q to the queue
 */
#define ADD_Q(PREV,Q) {\
	if ((PREV)->ptr[NEXT]) {\
	    (PREV)->ptr[NEXT]->ptr[LAST] = (Q);\
	}\
	(Q)->ptr[NEXT] = (PREV)->ptr[NEXT];\
	(PREV)->ptr[NEXT] = (Q);\
	(Q)->ptr[LAST] = (PREV);}

/*
 * Add DB to the previous LSDB entry
 */
#define ADD_DBQ(PREV,DB) {\
	if (DB_PTR(PREV)[NEXT]) {\
	    DB_PTR(DB_PTR(PREV)[NEXT])[LAST] = (DB);\
	}\
	DB_PTR(DB)[NEXT] = DB_PTR(PREV)[NEXT];\
	DB_PTR(PREV)[NEXT] = (DB);\
	DB_PTR(DB)[LAST] = (PREV);}


/*
 * Remove Q from the queue
 */
#define DEL_Q(Q,NK,TYPE) {\
	if ((Q)->ptr[LAST]) (Q)->ptr[LAST]->ptr[NEXT] = (Q)->ptr[NEXT];\
	if ((Q)->ptr[NEXT]) (Q)->ptr[NEXT]->ptr[LAST] = (Q)->ptr[LAST];\
	(Q)->ptr[NEXT] = ((Q)->ptr[LAST] = 0);\
	if (NK) ZAP(((char *)(Q)),TYPE);}

/*
 * Remove DB from the queue
 */
#define DEL_DBQ(DB) {\
      if (DB_PTR(DB)[LAST]) DB_PTR(DB_PTR(DB)[LAST])[NEXT] = DB_PTR(DB)[NEXT];\
      if (DB_PTR(DB)[NEXT]) DB_PTR(DB_PTR(DB)[NEXT])[LAST] = DB_PTR(DB)[LAST];\
      DB_PTR(DB)[NEXT] = (DB_PTR(DB)[LAST] = LSDBNULL);}


/*
 * These queue macros assume that the queue doesn't have a head
 */
#define EN_DBQ(QHP,DB) {\
	if (!(QHP)){\
		(QHP) = DB; DB_PTR(DB)[LAST] = LSDBNULL;\
	} else ADD_DBQ((QHP),DB);}

#define REM_DBQ(QHP,DB) {\
	if ((QHP) == (DB)) {\
		QHP = DB_PTR((DB))[NEXT];\
        	if (QHP) DB_PTR((QHP))[LAST] = LSDBNULL;\
  			DB_PTR(DB)[NEXT] = (DB_PTR(DB)[LAST] = LSDBNULL);\
	} else DEL_DBQ((DB));}

#define EN_Q(QHP,Q) {\
	if (!(QHP)){\
		(QHP) = (Q); (Q)->ptr[LAST] = 0;\
	} else ADD_Q((QHP),(Q));}

/* MODIFIED 1/23/92 */
#define REM_Q(QHP,Q,NK,TYPE) {\
            if ((QHP) == (Q)) {\
                (QHP) = (Q)->ptr[NEXT];\
                if (QHP) (QHP)->ptr[LAST] = 0;\
                if (NK) ZAP(((char *)(Q)),TYPE);\
                else (Q)->ptr[NEXT] = ((Q)->ptr[LAST] = 0);\
            } else DEL_Q((Q), NK, TYPE);}
