/*******************************************************************************
*									       *
*                U   U M   M DDDD     OOOOO SSSSS PPPPP FFFFF		       *
*                U   U MM MM D   D    O   O S     P   P F		       *
*                U   U M M M D   D    O   O  SSS  PPPPP FFFF		       *
*                U   U M M M D   D    O   O     S P     F		       *
*                 UUU  M M M DDDD     OOOOO SSSSS P     F		       *
*									       *
*    		          Copyright 1989, 1990, 1991               	       *
*    	       The University of Maryland, College Park, Maryland.	       *
*								               *
*			    All Rights Reserved				       *
*									       *
*     The University of Maryland College Park ("UMCP") is the owner of all     *
*     right, title and interest in and to UMD OSPF (the "Software").           *
*     Permission to use, copy and modify the Software and its documentation    *
*     solely for non-commercial purposes is granted subject to the following   *
*     terms and conditions:						       *
*								               *
*     1. This copyright notice and these terms shall appear in all copies      *
*	 of the Software and its supporting documentation.		       *
*									       *
*     2. The Software shall not be distributed, sold or used in any way in     *
*	 a commercial product, without UMCP's prior written consent.           *
*									       *
*     3. The origin of this software may not be misrepresented, either by      *
*        explicit claim or by omission.					       *
*    									       *
*     4. Modified or altered versions must be plainly marked as such, and      *
*	 must not be misrepresented as being the original software.	       *
*     									       *
*     5. The Software is provided "AS IS". User acknowledges that the          *
*        Software has been developed for research purposes only. User          *
*	 agrees that use of the Software is at user's own risk. UMCP	       *
*	 disclaims all warrenties, express and implied, including but          *
*	 not limited to, the implied warranties of merchantability, and        *
*	 fitness for a particular purpose.				       *
*									       *
*    Royalty-free licenses to redistribute UMD OSPF are available from	       *
*    The University Of Maryland, College Park. 			               *
*      For details contact:						       *
*	        Office of Technology Liaison 				       *
*		4312 Knox Road     					       *
*		University Of Maryland					       *
*		College Park, Maryland 20742				       *
*		     (301) 405-4209					       *
*		FAX: (301) 314-9871    					       *
*									       *
*    This software was written by Rob Coltun				       *
*     rcoltun@ni.umd.edu						       *
*									       *
*******************************************************************************/

extern char *ls_types[];
extern char *ctime();
extern long cumlog[];
extern u_long32 ospf_log_flags;
char _ospf_prt_buf[200];
int __mon_fd;				/* for monitor request */

/**************************************************************************
	
			OLOG CODES

***************************************************************************/

#ifndef DBG
#define MON_WRITE(BUF)	write(__mon_fd,BUF,strlen(BUF))
/*
#define OSPF_LOG(BUF) 	printf("%s\n",BUF)
*/
#define OSPF_LOG(BUF)
#define EVENT_UPDATE()
#define DBG_LOG(BUF)
#else
u_long32 __event_ref;

#define MON_WRITE(BUF)	{write(__mon_fd,BUF,sizeof(BUF));\
			 fprintf(iologfp,"%s\n",BUF);\
			 fflush(iologfp);\
			}
#define OSPF_LOG(BUF) 	{printf("%s\n",BUF);\
			 fprintf(iologfp,"%s\n",BUF);\
			 fflush(iologfp);\
			}
#define EVENT_UPDATE()  { __event_ref++;\
			  fprintf(iologfp,"EVENT_REF: %d\n",__event_ref);\
			  fflush(iologfp);\
			  fprintf(dumpfp,"EVENT_REF: %d\n",__event_ref);\
			  fflush(dumpfp);}

#define DBG_LOG(BUF) 	{ fprintf(iologfp,"%s\n",BUF);\
			  fflush(iologfp); }
#endif

#define DEFAULT_LOG_FLAGS (DD_LOG | REQ_LOG | LSU_LOG | ACK_LOG | OSPF_TRANS_LOG | OSPF_TRAP_LOG | BUILD_LSA_LOG | RUN_SPF_LOG)

#define HELLO_LOG	0x00000001
#define DD_LOG		0x00000002
#define REQ_LOG		0x00000004
#define LSU_LOG		0x00000008
#define ACK_LOG		0x00000010
#define RX_LOG_ALL	0x0000001f
#define BUILD_LSA_LOG	0x00000020	/* log when building LSA */
#define RUN_SPF_LOG	0x00000040	/* log when running spf algorithm */
#define TX_LSA_LOG	0x00000080	/* log each LSA type being flooded */
#define RX_LSA_LOG	0x00000100	/* log each received LSA */
#define OSPF_TRAP_LOG	0x00000200
#define OSPF_TIMER_LOG	0x00000400
#define OSPF_TRANS_LOG	0x00000800
#define OSPF_PKT_LOG	0x00001000	/* Pkt dump */

#ifndef UMBC_SIM
#define	LOG_RTAB(TYPE,ID,DEST)
#define	LOG_LSDB(TYPE,ID,LSTYPE,K0,K1)
#endif

#define GOOD_IPSUM	0xFFFF		/* good checksum could be -0 on some machines */

#define GOOD_RX		0

/* receive types */
#define	GOOD_MON	0
#define	GOOD_HELLO	1
#define	GOOD_DB_DESCRIPT	2
#define	GOOD_LSR	3
#define	GOOD_LSU	4
#define	GOOD_LSA	5
/* send types
#define		O_MON
#define		O_HELLO
#define		O_DB_DESCRIPT
#define		O_LSR
#define		O_LSU
#define		O_LSA
*/

#define	BAD_OSPF_TYPE	12
#define BAD_IP_DEST	13
#define BAD_IP_PROTOID	14
#define	MY_IP_SRC	15
#define BAD_OSPF_VERSION	16
#define	BAD_OSPF_CHKSUM	17
#define BAD_IF_AREAID	18
#define RXPACKET_TO_ABR	19
#define BAD_VL		20
#define	BAD_AUTH_TYPE	21
#define	BAD_AUTH_KEY	22
#define	PKT_TOO_SMALL	23
#define BAD_OSPF_LENGTH	24
#define	TX_SENDTO_BAD	25
#define	RX_ON_DOWN_IF   26
#define BAD_HELLO_MASK  27
#define BAD_HELLO_TIMER 28
#define BAD_DEAD_TIMER 	29
#define BAD_HELLO_E_bit 30
#define HELLO_ID_CONFUSION 31
#define UNKNOWN_VIRT_NBR 32
#define UNKNOWN_NBMA_NBR 33
#define CANT_FIND_NBR1  34
#define LOW_NBR_STATE1	35
#define BAD_RTRID  	36
#define BAD_DD_E_bit	37
#define NO_ACK_NBR	38
#define LOW_NBR_STATE3	39
#define LOW_NBR_STATE4	40
#define CANT_FIND_NBR4	41
#define EMPTY_LS_REQ	42
#define BOGUS_REQ       43
#define LOW_NBR_STATE2	44
#define CANT_FIND_NBR2	45
#define NEWER_LSU	46
#define BAD_LS_CHKSUM   47
#define UNUSUAL_INSTANCE 48
#define BAD_LSA_TYPE 	49

#define LASTLOG		50		/* best if even for err_dump() */

#define adios(PARM) {fprintf(stderr,"%s\n",PARM);ospf_bye();}

#ifdef __OSPF_D
#define ciao(PARM) {fprintf(stderr,"%s\n",PARM);exit(1);}
#define s2c(S)	(ctime(S))		/* secondes to char */
#endif

#define TRANS_LOG(T,E,C,N,I) {if (ospf_log_flags & OSPF_TRANS_LOG) translog(T,E,C,N,I);}


#define RTR_LSA_LOG(A,C,S,SEC)\
	{if (ospf_log_flags & BUILD_LSA_LOG)\
    	{sprintf(_ospf_prt_buf,"Build RTR LSA area: %s lnks: %d seq: %x ",\
			lntoa(A), C, S); \
              OSPF_LOG(_ospf_prt_buf);}}

#define	NET_LSA_LOG(A,N,S,SEC)\
	{if (ospf_log_flags & BUILD_LSA_LOG)\
	     {sprintf(_ospf_prt_buf,"Build NET LSA area: %s net: %s seq: %x",\
			lntoa(A),N,S);\
              OSPF_LOG(_ospf_prt_buf);}}

#define	BUILD_SUM_LOG(A,SEC)\
	{if (ospf_log_flags & BUILD_LSA_LOG)\
	     {sprintf(_ospf_prt_buf,"Building SUM LSA from area: %s",lntoa(A));\
              OSPF_LOG(_ospf_prt_buf);}}

#define	BUILD_INTER_LOG(SEC)\
	{if (ospf_log_flags & BUILD_LSA_LOG)\
	     {sprintf(_ospf_prt_buf,"Building INTER-AREA LSA from backbone");\
              OSPF_LOG(_ospf_prt_buf);}}

#define SUM_TYPE_LOG(A,T,I,S,M)\
	{if (ospf_log_flags & BUILD_LSA_LOG)\
	    {sprintf(_ospf_prt_buf,"   dst area %s type %s id %s seq %x metric %d",\
			lntoa(A),T,I,S,M);\
              OSPF_LOG(_ospf_prt_buf);}}

#define	ASE_LSA_LOG(SEC)\
	{if (ospf_log_flags & BUILD_LSA_LOG)\
	    {sprintf(_ospf_prt_buf,"Building ASE LSAs");\
              OSPF_LOG(_ospf_prt_buf);}}

#define ASE_TYPE_LOG(N,T,S,M)\
	{if (ospf_log_flags & BUILD_LSA_LOG)\
	     {sprintf(_ospf_prt_buf,"   net %s type %d seq %x metric %d",N,T,S,M);\
             OSPF_LOG(_ospf_prt_buf);}}

#define ASE_IMPORT_LOG(C)\
	{if (ospf_log_flags & BUILD_LSA_LOG)\
	     {sprintf(_ospf_prt_buf,"ASE Import: net %s action %s proto %d",\
			lntoa(RT_DEST((C).route)),\
			((C).action == E_DELETE) ? "Delete" : "Add or change",\
			(C).proto);\
             OSPF_LOG(_ospf_prt_buf);}}

#define TIMER_LOG(S) {if (ospf_log_flags & OSPF_TIMER_LOG)\
	{sprintf(_ospf_prt_buf,"%s",(S));\
              OSPF_LOG(_ospf_prt_buf);}}

#define RX_LOG(MC,T,I,S) rxlog(MC,T,I,S)

#define	TX_LOG(MC,T,N,R,TO) txlog(MC,T,N,R,TO)

#define SINGLE_LOG(TYPE,ID,K0,K1)\
	{if (ospf_log_flags & RUN_SPF_LOG)\
	     {sprintf(_ospf_prt_buf,"Adding single %s LSA area: %s adv rtr: %s ls id: %s",\
				TYPE,lntoa(ID),K0,K1);\
              OSPF_LOG(_ospf_prt_buf);}}

#define	SPFRUN_LOG(TYPE,ID)\
	{if (ospf_log_flags & RUN_SPF_LOG) {\
		sprintf(_ospf_prt_buf,"%s run: area %s",TYPE,lntoa(ID));\
              OSPF_LOG(_ospf_prt_buf);}}

#define CHOOSE_DR_LOG(A) \
	      {if (ospf_log_flags & OSPF_TRANS_LOG)\
		{sprintf(_ospf_prt_buf,"CHOOSING DR Intf %s: ",A);\
              OSPF_LOG(_ospf_prt_buf);}}

#define	DR_LOG(A) {if (ospf_log_flags & OSPF_TRANS_LOG)\
		{sprintf(_ospf_prt_buf,"DR = %s ",A);\
              OSPF_LOG(_ospf_prt_buf);}}

#define	BDR_LOG(A) {if (ospf_log_flags & OSPF_TRANS_LOG)\
		{sprintf(_ospf_prt_buf,"BDR = %s",A);\
              OSPF_LOG(_ospf_prt_buf);}}


#define FREE_LOG(TYPE,K0,K1)\
	{if (ospf_log_flags & OSPF_TRANS_LOG)\
	{sprintf(_ospf_prt_buf,"Freeing db type %s link id %s adv rtr %s",TYPE,K0,K1);\
              OSPF_LOG(_ospf_prt_buf);}}

#define	IF_DOWN_LOG(N,A)\
	{sprintf(_ospf_prt_buf,"TQ_IFCHECK: Interface %s (%s) is down",N,A);\
              OSPF_LOG(_ospf_prt_buf);}

#define PKT_LOG(FP,H,L,TYPE,D,SRC) \
  if ((OSPF_PKT_LOG & ospf_log_flags) && (TYPE) >= 1) pkt_log(FP,H,L,TYPE,D,SRC)

#define CHECKSUM_LOG(OLD,NEW,TYPE,LEN)\
	{if (ospf_log_flags & OSPF_TRANS_LOG)\
   	{sprintf(_ospf_prt_buf,"Bad checksum: old %x new %x type %d len %d",OLD,NEW,TYPE,LEN);\
              OSPF_LOG(_ospf_prt_buf);}}
